package com.zhongzheng.modules.base.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.base.bo.ProfileFieldAddBo;
import com.zhongzheng.modules.base.bo.ProfileFieldEditBo;
import com.zhongzheng.modules.base.bo.ProfileFieldQueryBo;
import com.zhongzheng.modules.base.domain.ProfileField;
import com.zhongzheng.modules.base.mapper.ProfileFieldMapper;
import com.zhongzheng.modules.base.service.IProfileFieldService;
import com.zhongzheng.modules.base.vo.ProfileFieldVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 资料字段Service业务层处理
 *
 * @author hjl
 * @date 2021-11-19
 */
@Service
public class ProfileFieldServiceImpl extends ServiceImpl<ProfileFieldMapper, ProfileField> implements IProfileFieldService {

    @Override
    public ProfileFieldVo queryById(Long fieldId){
        ProfileField db = this.baseMapper.selectById(fieldId);
        return BeanUtil.toBean(db, ProfileFieldVo.class);
    }

    @Override
    public List<ProfileFieldVo> queryList(ProfileFieldQueryBo bo) {
        LambdaQueryWrapper<ProfileField> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getFieldName()), ProfileField::getFieldName, bo.getFieldName());
        lqw.eq(StrUtil.isNotBlank(bo.getFieldKey()), ProfileField::getFieldKey, bo.getFieldKey());
        lqw.eq(bo.getStatus() != null, ProfileField::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ProfileFieldVo> entity2Vo(Collection<ProfileField> collection) {
        List<ProfileFieldVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ProfileFieldVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ProfileField> page = (Page<ProfileField>)collection;
            Page<ProfileFieldVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ProfileFieldAddBo bo) {
        ProfileField add = BeanUtil.toBean(bo, ProfileField.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ProfileFieldEditBo bo) {
        ProfileField update = BeanUtil.toBean(bo, ProfileField.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ProfileField entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
